#include <ESP8266WiFi.h> // NodeMCU kurulumuyla gelir.
#include <ESP8266WebServer.h> // NodeMCU kurulumuyla gelir.

/*Ağ adınızı ve Şifrenizi Giriniz*/
const char* kablosuzAgAdi = "ZyXEL";  // Ağ adınızı girin.
const char* sifre = "CK4YTTFPACTL";  //Ağ şifrenizi girin.

ESP8266WebServer server(80); //80 portunu kullanarak bir server isimli nesne oluşturdu.

const byte salonPin = D0, mutfakPin = D1, yatakPin = D2, banyoPin = D3;
bool salonDurum, mutfakDurum, yatakDurum, banyoDurum;

void setup() {
  Serial.begin(9600);
  delay(100);
  pinMode(salonPin, OUTPUT);
  pinMode(mutfakPin, OUTPUT);
  pinMode(yatakPin, OUTPUT);
  pinMode(banyoPin, OUTPUT);

  Serial.println(kablosuzAgAdi);
  Serial.println(" Ağına Bağlanılıyor");

  WiFi.begin(kablosuzAgAdi, sifre);

  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("Ağ bağlantısı sağlandı.");
  Serial.print("IP Adresiniz: ");  Serial.println(WiFi.localIP());

  server.on("/", hepsiKapali);
  server.on("/s1", salonAcik);
  server.on("/s0", salonKapali);
  server.on("/m1", mutfakAcik);
  server.on("/m0", mutfakKapali);
  server.on("/y1", yatakAcik);
  server.on("/y0", yatakKapali);
  server.on("/b1", banyoAcik);
  server.on("/b0", banyoKapali);
  server.onNotFound(sayfaBulunamadi);

  server.begin();
  Serial.println("HTTP Sunucusu Başlatıldı");
}
void loop() {
  server.handleClient();
  if (salonDurum)
    digitalWrite(salonPin, HIGH);
  else
    digitalWrite(salonPin, LOW);

  if (mutfakDurum)
    digitalWrite(mutfakPin, HIGH);
  else
    digitalWrite(mutfakPin, LOW);

  if (yatakDurum)
    digitalWrite(yatakPin, HIGH);
  else
    digitalWrite(yatakPin, LOW);

  if (banyoDurum)
    digitalWrite(banyoPin, HIGH);
  else
    digitalWrite(banyoPin, LOW);
}

void hepsiKapali() {
  salonDurum = LOW;
  mutfakDurum = LOW;
  yatakDurum = LOW;
  banyoDurum = LOW;
  server.send(200, "text/html", HTML(salonDurum, mutfakDurum, yatakDurum, banyoDurum ));
}

void salonAcik() {
  salonDurum = HIGH;
  server.send(200, "text/html", HTML(true, mutfakDurum, yatakDurum, banyoDurum));
}

void salonKapali() {
  salonDurum = LOW;
  server.send(200, "text/html", HTML(false, mutfakDurum, yatakDurum, banyoDurum));
}

void mutfakAcik() {
  mutfakDurum = HIGH;
  server.send(200, "text/html", HTML(salonDurum, true, yatakDurum, banyoDurum));
}

void mutfakKapali() {
  mutfakDurum = LOW;
  server.send(200, "text/html", HTML(salonDurum, false, yatakDurum, banyoDurum));
}

void yatakAcik() {
  yatakDurum = HIGH;
  server.send(200, "text/html", HTML(salonDurum, mutfakDurum, true, banyoDurum));
}

void yatakKapali() {
  yatakDurum = LOW;
  server.send(200, "text/html", HTML(salonDurum, mutfakDurum, false, banyoDurum));
}

void banyoAcik() {
  banyoDurum = HIGH;
  server.send(200, "text/html", HTML(salonDurum, mutfakDurum, yatakDurum, true));
}

void banyoKapali() {
  banyoDurum = LOW;
  server.send(200, "text/html", HTML(salonDurum, mutfakDurum, yatakDurum, false));
}

void sayfaBulunamadi() {
  server.send(404, "text/plain", "Sayfa Bulunamadı");
}

String HTML(uint8_t salonDurum, uint8_t mutfakDurum, uint8_t yatakDurum, uint8_t banyoDurum) {
  String metin = "<!DOCTYPE html> <html>\n";
  metin += "<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no\">\n";
  metin += "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=UTF-8\">";
  metin += "<title>Akıllı ev aydınlatma uygulaması</title>\n";
  metin += "<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}\n";
  metin += "body{margin-top: 50px;} h1 {color: #444444;margin: 50px auto 30px;} h3 {color: #444444;margin-bottom: 50px;}\n";
  metin += ".button {display: block;width: 80px;background-color: #1abc9c;border: none;color: white;padding: 13px 30px;text-decoration: none;font-size: 25px;margin: 0px auto 35px;cursor: pointer;border-radius: 4px;}\n";
  metin += ".button-on {background-color: #1abc9c;}\n";
  metin += ".button-on:active {background-color: #16a085;}\n";
  metin += ".button-off {background-color: #34495e;}\n";
  metin += ".button-off:active {background-color: #2c3e50;}\n";
  metin += "p {font-size: 14px;color: #888;margin-bottom: 10px;}\n";
  metin += "</style>\n";
  metin += "</head>\n";
  metin += "<body>\n";
  metin += "<h1>Akıllı ev aydınlatma uygulaması</h1>\n";

  if (salonDurum)
    metin += "<p>Salon</p><a class=\"button button-off\" href=\"/s0\">KAPAT</a>\n";
  else
    metin += "<p>Salon</p><a class=\"button button-on\" href=\"/s1\">AÇ</a>\n";

  if (mutfakDurum)
    metin += "<p>Mutfak</p><a class=\"button button-off\" href=\"/m0\">KAPAT</a>\n";
  else
    metin += "<p>Mutfak</p><a class=\"button button-on\" href=\"/m1\">AÇ</a>\n";
  if (yatakDurum)
    metin += "<p>Yatak odası</p><a class=\"button button-off\" href=\"/y0\">KAPAT</a>\n";
  else
    metin += "<p>Yatak odası</p><a class=\"button button-on\" href=\"/y1\">AÇ</a>\n";
  if (banyoDurum)
    metin += "<p>Banyo</p><a class=\"button button-off\" href=\"/b0\">KAPAT</a>\n";
  else
    metin += "<p>Banyo</p><a class=\"button button-on\" href=\"/b1\">AÇ</a>\n";

  metin += "</body>\n";
  metin += "</html>\n";
  metin += "<h3>ESP Station(STA) Modunda Kullanılıyor</h3>\n";
  return metin;
}
